from .clients_aggregator import create_gradio2api
from .dataclasses import Gradio2APIConfig
import argparse
import uvicorn
import gradio as gr
import yaml


def cli_remote():
    parser = argparse.ArgumentParser(
        description="""\
    Sample command:
    ```sh
    gradio2api config.yaml --host 0.0.0.0 --port 8000
    ```
    """,
        formatter_class=argparse.ArgumentDefaultsHelpFormatter,
    )
    parser.add_argument("config_file", type=str,
                        help="""config filepath""")
    parser.add_argument("--host", type=str,
                        default="127.0.0.1", help="The host for uvicorn.")
    parser.add_argument("--port", type=int, default=8000,
                        help="The port for uvicorn.")

    kwargs = parser.parse_args().__dict__
    config_file = kwargs.pop("config_file")
    host = kwargs.pop("host")
    port = kwargs.pop("port")

    _config = yaml.safe_load(open(config_file))

    gradio2api_config = Gradio2APIConfig(**_config).model_dump()

    app, _ = create_gradio2api(**gradio2api_config)

    uvicorn.run(
        app,
        host=host,
        port=port,
    )


if __name__ == "__main__":
    cli_remote()
